#-----------------------------------------------------------------------------
# Snap-to-cam
# Jul 26, 07
# Copyright (c) 2007 by David G. Drumright (ockham)
# Select the 'mover' before hitting the script.
# The 'mover' will go to the current camera.
#-----------------------------------------------------------------------------

import poser
import string
scene=poser.Scene()

Mover=scene.CurrentActor()
Dest=scene.CurrentCamera()

scene.DrawAll()
# Locate actual center of dest.
Geom=Dest.Geometry()
MinX= 10000.0
MinY= 10000.0
MinZ= 10000.0
MaxX=-10000.0
MaxY=-10000.0
MaxZ=-10000.0
for v in range(Geom.NumVertices()):
    WV=Geom.WorldVertex(v)
    if   WV.X() > MaxX: MaxX=WV.X()
    elif WV.X() < MinX: MinX=WV.X()
    if   WV.Y() > MaxY: MaxY=WV.Y()
    elif WV.Y() < MinY: MinY=WV.Y()
    if   WV.Z() > MaxZ: MaxZ=WV.Z()
    elif WV.Z() < MinZ: MinZ=WV.Z()
DestX=(MaxX+MinX)/2.0
DestY=(MaxY+MinY)/2.0
DestZ=(MaxZ+MinZ)/2.0
Mover.ParameterByCode(poser.kParmCodeXTRAN).SetValue(DestX)
Mover.ParameterByCode(poser.kParmCodeYTRAN).SetValue(DestY)
Mover.ParameterByCode(poser.kParmCodeZTRAN).SetValue(DestZ)
scene.SelectActor(Mover) # return to the item we're trying to move
scene.DrawAll()

